
% ===============================================
% SwingStance_Metachronal.m
% CBP 11-11-23
% Metachronal gait all legs and feet
% ===============================================
period = 10;
endTime = 1.5*period;

time = [0:0.1:endTime];

drive1 = sin(2*pi*time/period);
drive2 = sin(2*pi*time/period - pi/3);
drive3 = sin(2*pi*time/period - 2*pi/3);

drive4 = sin(2*pi*time/period - 3*pi/3);
drive5 = sin(2*pi*time/period - 4*pi/3);
drive6 = sin(2*pi*time/period - 5*pi/3);

liftThresh = sin(pi/3);

% Calculate the lift
for i = 1: length(drive1)
  if (drive1(i) > liftThresh)
    lift1(i) = 1;
  else
    lift1(i) = 0;
  endif
endfor

for i = 1: length(drive2)
  if (drive2(i) > liftThresh)
    lift2(i) = 1;
  else
    lift2(i) = 0;
  endif
endfor

for i = 1: length(drive3)
  if (drive3(i) > liftThresh)
    lift3(i) = 1;
  else
    lift3(i) = 0;
  endif
endfor

for i = 1: length(drive4)
  if (drive4(i) > liftThresh)
    lift4(i) = 1;
  else
    lift4(i) = 0;
  endif
endfor

for i = 1: length(drive5)
  if (drive5(i) > liftThresh)
    lift5(i) = 1;
  else
    lift5(i) = 0;
  endif
endfor

for i = 1: length(drive6)
  if (drive6(i) > liftThresh)
    lift6(i) = 1;
  else
    lift6(i) = 0;
  endif
endfor

% Calculate the swing
threshold = input("Input threshold ");

for i = 1: length(drive1)
  if (drive1(i) > threshold) && (lift1(i) > 0)
    swing1(i) = 1;
  elseif (drive1(i) < liftThresh) && (lift1(i) <= 0)
    swing1(i) = -1;
  else
    swing1(i) = 0;
  endif
endfor

for i = 1: length(drive2)
  if (drive2(i) > threshold) && (lift2(i) > 0)
    swing2(i) = 1;
  elseif (drive2(i) < liftThresh) && (lift2(i) <= 0)
    swing2(i) = -1;
  else
    swing2(i) = 0;
  endif
endfor

for i = 1: length(drive3)
  if (drive3(i) > threshold) && (lift3(i) > 0)
    swing3(i) = 1;
  elseif (drive3(i) < liftThresh) && (lift3(i) <= 0)
    swing3(i) = -1;
  else
    swing3(i) = 0;
  endif
endfor

for i = 1: length(drive4)
  if (drive4(i) > threshold) && (lift4(i) > 0)
    swing4(i) = 1;
  elseif (drive4(i) < liftThresh) && (lift4(i) <= 0)
    swing4(i) = -1;
  else
    swing4(i) = 0;
  endif
endfor

for i = 1: length(drive5)
  if (drive5(i) > threshold) && (lift5(i) > 0)
    swing5(i) = 1;
  elseif (drive5(i) < liftThresh) && (lift5(i) <= 0)
    swing5(i) = -1;
  else
    swing5(i) = 0;
  endif
endfor

for i = 1: length(drive6)
  if (drive6(i) > threshold) && (lift6(i) > 0)
    swing6(i) = 1;
  elseif (drive6(i) < liftThresh) && (lift6(i) <= 0)
    swing6(i) = -1;
  else
    swing6(i) = 0;
  endif
endfor


figure(1)
subplot(4,1,1);
plot(time,drive1,'linewidth',1.5,time,drive2,'linewidth',1.5,time,drive3,'linewidth',1.5);
title('Drive');
grid;
axis([0,endTime,-1.5,1.5]);

subplot(4,1,2);
plot(time,drive1,time,lift1,'linewidth',1.5,time,swing1,'linewidth',1.5);
title('LF');
grid;
axis([0,endTime,-1.5,1.5]);

subplot(4,1,3);
plot(time,drive2,time,lift2,'linewidth',1.5,time,swing2,'linewidth',1.5);
title('LM');
grid;
axis([0,endTime,-1.5,1.5]);

subplot(4,1,4);
plot(time,drive3,time,lift3,'linewidth',1.5,time,swing3,'linewidth',1.5);
title('LR');
grid;
axis([0,endTime,-1.5,1.5]);

figure(2)
subplot(4,1,1);
plot(time,drive4,'linewidth',1.5,time,drive5,'linewidth',1.5,time,drive6,'linewidth',1.5);
title('Drive');
grid;
axis([0,endTime,-1.5,1.5]);

subplot(4,1,2);
plot(time,drive4,time,lift4,'linewidth',1.5,time,swing4,'linewidth',1.5);
title('RR');
grid;
axis([0,endTime,-1.5,1.5]);

subplot(4,1,3);
plot(time,drive5,time,lift5,'linewidth',1.5,time,swing5,'linewidth',1.5);
title('RM');
grid;
axis([0,endTime,-1.5,1.5]);

subplot(4,1,4);
plot(time,drive6,time,lift6,'linewidth',1.5,time,swing6,'linewidth',1.5);
title('RF');
grid;
axis([0,endTime,-1.5,1.5]);
